@echo off
::
:: File Regbkup.bat backs up our Windows 95 registry before starting
:: the graphical environment.

:: Copyright (c) 1996 by Tessler's Nifty Tools All Rights Reserved.
::       http://ourworld.compuserve.com/homepages/NIFTY_TOOLS
::
:: Uses PC Magazine's Strings.com program (freeware) which may be found at:
::       http://www.zdnet.com/pcmag/utils/strings.htm

:: Uses PKZIP from PKWARE to compress the registry. (shareware)

:: This batch file assumes that Windows 95 is installed on your \WIN95
:: area of your F: disk. Change the next two "set=" lines to match your
:: system requirements...

:: It will save the last 10 versions of your registry into F:\WIN95\REGBACK
:: After 10 versions are saved, the oldest version is erased to make room
:: for the next version.

:: ************** Typical user stuff below here ***********************
:: drive letter of where win95 is installed
set dr=F:

:: set loc of our reg files which is also where Windows 95 is installed
set reg_loc=%dr%\WIN95
:: ************** Typical user stuff above here ***********************


:: location & name of our data file. store it in the root for easy finding 
:: in time of need. The data file holds the suffix of the next filename
:: that will hold our registry copy.
set dat_file=%dr%\REGBKUP.DAT

:: set location of our backup registry directory
set reg_back_loc=%dr%\WIN95\REGBACK

:: maxsave is number of registry copies to save on PC
set maxsave=10

:: prefix of zip file
set prefix=W95REG

:: default counter that we will save at this time w/o a dat file
set next_save_at=1

:: temp var
set res=


::**********start of stuff******************************************


if exist %dat_file% goto read_dat
	:: dat file missing
	:: create new file with ptr == 1
	:: default is 1 already

	goto skip1
::else
:read_dat
	:: get our pointer from our dat file
	strings /q next_save_at = read %dat_file%, 1
::end
:skip1


::********************************************
:: save to this file now...
::********************************************

:: make sure our sub-dir exists
md %reg_back_loc% > nul
cls

echo TNT's RegBkUp.bat is saving a zipped copy of Win95's registry (to #%next_save_at% of %maxsave%)...
echo .
echo Copyright (c) 1996 by Tessler's Nifty Tools All Rights Reserved.
echo .
echo    Visit us at:  http://ourworld.compuserve.com/homepages/NIFTY_TOOLS
echo .
echo .
%dr%\win95\regedit /L:%reg_loc%\system.dat /R:%reg_loc%\user.dat /E %reg_back_loc%\%prefix%.TMP
set zipname=%reg_back_loc%\%prefix%%next_save_at%.ZIP 
attrib -r %zipname%
pkzip -a %zipname% %reg_back_loc%\%prefix%.TMP > nul
attrib +r %zipname%
del %reg_back_loc%\%prefix%.TMP

::save next ptr to disk
attrib -r %dat_file%

strings /q next_save_at = add %next_save_at%, 1

:: if greater than max, reset to 1...
strings /q res = sub %maxsave%, %next_save_at% 
cls

if not %res%y==y goto skip2
	:: need to reset
	
	set next_save_at=1
::end
:skip2

:: save to disk

del %dat_file%
strings /q write %dat_file%, %next_save_at%
attrib +r %dat_file%

echo Done saving the registry...

:end
	:: cleanup
	set maxsave=
	set next_save_at=
	set prefix=
	set res=
	set reg_back_loc=
	set dr=
	set dat_file=
	set reg_loc=
	set zipname=